var renderer = require("./renderer");

function combyne(template, context) {
  if(!(this instanceof combyne)) {
    return new combyne(template, context);
  }

  this.template = template;
  this.context = context || {};

  function addon() {
    return {
      _cache: {},
      // Read
      get: function(name) {
        return this._cache[name];
      },
      // Delete
      remove: function(name) {
        delete this._cache[name];
      }
    };
  }

  this.filters = addon();
  this.filters.add = function(name, cb) {
    this._cache[name] = _wrapFilter(cb);
  };

  this.partials = addon();
  this.partials.add = function(name, template, context) {
    this._cache[name] = { template: template, context: context };
  };
}

combyne.version = "0.1.2";
combyne.prototype = {

  render: function() {
    var self = this;

    // Missing template or context... can't exactly do anything here...
    if (!self.template || !self.context) {
      //throw new Error("Missing template or context");
    } 

    // Override delimiters
    self.delimiters = self.delimiters || {};
    self.delimiters.__proto__ = {
      START_PROP: "{{",
      END_PROP: "}}",
      START_EXPR: "{%",
      END_EXPR: "%}",
      COMMENT: "--",
      FILTER: "|"
    };

    // Actually render
    return renderer(self, self.template, self.context, self.delimiters);
  },

  delimiters: {}
};

function _wrapFilter(func) {
  var self = this;
  var context;

  return function() {
    context = context ? context : { original: self.template };

    return func.apply(context, arguments);
  };
}

module.exports = combyne;

//Express Support 
module.exports.compile = function(markup) {
  return function(locals) {
    return combyne(markup, locals).render();
  };
}
